blog/urls.py
from django.urls import path
from . import views
from .views import (
    PostListView,
    PostDetailView,
    PostCreateView,
    PostUpdateView,
    PostDeleteView,
    UserPostListView,
    PostLikeToggle,
    PostLikeAPIToggle,
)

urlpatterns = [
    path('', PostListView.as_view(), name='blog-home'),
    path('post/<slug:slug>/', PostDetailView.as_view(), name='post-detail'),
    path('post/<slug:slug>/like/', PostLikeToggle.as_view(), name='like-toggle'),
    path('api/<slug:slug>/like/',
         PostLikeAPIToggle.as_view(), name='like-api-toggle'),
    path('create/new/', PostCreateView.as_view(), name='post-create'),
    path('post/<slug:slug>/update/', PostUpdateView.as_view(), name='post-update'),
    path('post/<slug:slug>/delete/', PostDeleteView.as_view(), name='post-delete'),
    # path('users/', ),
    path('users/<str:username>', UserPostListView.as_view(), name='user-posts'),
    path('post/<slug:slug>/comment/', views.comment, name='comments'),
    path('tag/<slug:slug>/', views.tag_detail, name='tag-detail'),
]

microtwitter/urls.py
from django.contrib import admin
from django.urls import path, include

from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('blog.urls')),
    path('accounts/', include('users.urls')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)

blog/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils import timezone
from django.shortcuts import reverse
from django.utils.text import slugify


class Tag(models.Model):
    title = models.CharField(max_length=100)
    slug = models.SlugField(unique=True)

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('tag-detail', kwargs={'slug': self.slug})

    def _get_unique_slug(self):
        slug = slugify(self.title)
        unique_slug = slug
        num = 1
        while Tag.objects.filter(slug=unique_slug).exists():
            unique_slug = '{}-{}'.format(slug, num)
            num += 1
        return unique_slug

    def save(self, *args, **kwargs):
        if not self.slug:
            self.slug = self._get_unique_slug()
        super().save(*args, **kwargs)


class Post(models.Model):
    title = models.CharField(max_length=100)
    slug = models.SlugField('slug', max_length=100, unique=True)
    content = models.TextField()
    date_posted = models.DateTimeField(default=timezone.now)
    author = models.ForeignKey(User, on_delete=models.CASCADE)
    tag = models.ManyToManyField(Tag, related_name='posts')
    likes = models.ManyToManyField(User, blank=True, related_name='post_likes')

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('post-detail', kwargs={'slug': self.slug})

    def _get_unique_slug(self):
        slug = slugify(self.title)
        unique_slug = slug
        num = 1
        while Post.objects.filter(slug=unique_slug).exists():
            unique_slug = '{}-{}'.format(slug, num)
            num += 1
        return unique_slug

    def save(self, *args, **kwargs):
        if not self.slug:
            self.slug = self._get_unique_slug()
        super().save(*args, **kwargs)

    def get_like_url(self):
        return reverse("like-toggle", kwargs={"slug": self.slug})

    def get_api_like_url(self):
        return reverse("like-api-toggle", kwargs={"slug": self.slug})


class Comment(models.Model):
    post = models.ForeignKey(
        Post, on_delete=models.CASCADE, related_name='comments')
    author = models.ForeignKey(
        User, on_delete=models.CASCADE, related_name='comments')
    body = models.TextField(max_length=1000)
    date = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.author

    class Meta:
        ordering = ['-date']

blog/views.py
from rest_framework import authentication, permissions
from rest_framework.response import Response
from rest_framework.views import APIView
from django.shortcuts import render, get_object_or_404, redirect, reverse
from django.contrib.auth.mixins import LoginRequiredMixin, UserPassesTestMixin
from django.contrib.auth.models import User
from .models import Post, Tag
from django.http import Http404, HttpResponseRedirect
from django.contrib.auth.decorators import login_required
from users.forms import UserRegisterForm
from django.contrib import messages

from django.views.generic import (
    ListView,
    DetailView,
    CreateView,
    UpdateView,
    DeleteView,
    RedirectView
)


def home(request):
    posts = Post.objects.all()
    context = {'posts': posts}
    return render(request, 'blog/home.html', context)


class PostListView(ListView):
    model = Post
    template_name = 'blog/home.html'
    context_object_name = 'posts'
    ordering = ['-date_posted']
    paginate_by = 5

    # def get_queryset(self):
    #     tag = self.request.GET.get('tag')
    #     return Tag.objects.filter(tag=tag)


class UserPostListView(ListView):
    model = Post
    template_name = 'blog/user_post.html'
    context_object_name = 'posts'
    paginate_by = 5

    def get_queryset(self):
        user = get_object_or_404(User, username=self.kwargs.get('username'))
        return Post.objects.filter(author=user).order_by('-date_posted')


class PostDetailView(DetailView):
    model = Post


class PostCreateView(LoginRequiredMixin, CreateView):
    model = Post
    fields = ['title', 'content', 'tag']

    def form_valid(self, form):
        form.instance.author = self.request.user
        # self.object = form.save(commit=False)
        # self.object.save()
        # form.instance.tag.add(form.cleaned_data('tags'))
        return super().form_valid(form)

    def get_context_data(self, **kwargs):
        context = super(PostCreateView, self).get_context_data(**kwargs)
        context.update({'tags': Tag.objects.all(), })
        return context


class PostUpdateView(LoginRequiredMixin, UserPassesTestMixin, UpdateView):
    model = Post
    fields = ['title', 'content']

    def form_valid(self, form):
        form.instance.author = self.request.user
        return super().form_valid(form)

    def test_func(self):
        post = self.get_object()
        if self.request.user == post.author:
            return True
        return False


class PostDeleteView(LoginRequiredMixin, UserPassesTestMixin, DeleteView):
    model = Post
    success_url = '/'

    def test_func(self):
        post = self.get_object()
        if self.request.user == post.author:
            return True
        return False


class PostLikeToggle(RedirectView):
    def get_redirect_url(self, *args, **kwargs):
        slug = self.kwargs.get('slug')
        print(slug)
        obj = get_object_or_404(Post, slug=slug)
        url_ = obj.get_absolute_url()
        user = self.request.user
        if user.is_authenticated:
            if user in obj.likes.all():
                obj.likes.remove(user)
            else:
                obj.likes.add(user)
        return url_


class PostLikeAPIToggle(APIView):
    authentication_classes = [authentication.SessionAuthentication]
    permission_classes = [permissions.IsAuthenticated, ]

    def get(self, request, slug=None, format=None):
        # slug = self.kwargs.get('slug')
        obj = get_object_or_404(Post, slug=slug)
        url_ = obj.get_absolute_url()
        user = self.request.user
        updated = False
        liked = False

        if user.is_authenticated:
            if user in obj.likes.all():
                liked = False
                obj.likes.remove(user)
            else:
                liked = True
                obj.likes.add(user)
            updated = True
        data = {
            'updated': updated,
            'liked': liked
        }
        return Response(data)


def comment(request, slug):
    if not request.user.is_authenticated:
        return redirect('login')
    try:
        post = Post.objects.get(slug__iexact=slug)
    except:
        raise Http404("Article not found")
    user = request.user
    post.comments.create(author=user,
                         body=request.POST.get('body'))
    return HttpResponseRedirect(reverse('post-detail', args=(post.slug,)))


def tags(request):
    tags = Tag.objects.all()
    return render(request, 'blog/tag.html', {'tags': tags})


def tag_detail(request, slug):
    tag = Tag.objects.get(slug__iexact=slug)
    return render(request, 'blog/tag_detail.html', context={'tag': tag})


# class TagDetailView(DeleteView):
#     template_name = 'blog/tag_detail'

blog/templates/blog/base.html
{% load static %}
{% load crispy_forms_tags %}
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <link rel="stylesheet" href="{% static 'blog/main.css' %}">

    <link rel="stylesheet" href="{% static 'blog/choices.css' %}">

    <link href="https://use.fontawesome.com/releases/v5.0.8/css/all.css" rel="stylesheet">

    <style>
        .main {
            display: flex;
            position: relative;
            flex-wrap: nowrap;
        }

        #content {
            width: 65%;
        }

        #sidebar {
            width: 35%;
            height: 100%;
            right: 0;
            position: fixed;
            border-left: 1px solid #ddd;
        }

        @media screen and (max-width: 970px) {
            #content {
                width: 100%;
                margin: 0;
            }

            #sidebar {
                width: 100%;
                position: relative;
            }

            .main {
                display: flex;
                flex-wrap: wrap;
            }
        }

        i.fa-heart {
            transition: .2s;
        }

        .heart i.fa-heart {
            color: #cc0000;
            font-size: 21px;
        }
    </style>

    {% if title %}
    <title>{{ title }}</title>
    {% else %}
    <title>Blog</title>
    {% endif %}
</head>

<body>

    <header class="site-header">
        <nav class="navbar navbar-expand-md navbar-dark bg-success fixed-top">
            <div class="container">
                <a class="navbar-brand mr-4" href="{% url 'blog-home' %}">MicroTwitter</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarToggle"
                    aria-controls="navbarToggle" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarToggle">
                    <div class="navbar-nav mr-auto">
                        <a class="nav-item nav-link" href="{% url 'blog-home' %}">Home</a>
                    </div>
                    <!-- Navbar Right Side -->
                    <div class="navbar-nav">
                        {% if user.is_authenticated %}
                        <a class="nav-item nav-link" href="{% url 'post-create' %}">New Post</a>
                        <a class="nav-item nav-link" href="{% url 'profile' %}">Profile</a>
                        <a class="nav-item nav-link" href="{% url 'logout' %}">Logout</a>
                        {% else %}
                        <a class="nav-item nav-link" href="{% url 'login' %}">Login</a>
                        <a class="nav-item nav-link" href="{% url 'register' %}">Register</a>
                        {% endif %}
                    </div>
                </div>
            </div>
        </nav>
    </header>
    <main role="main" class="container">
        <div class="row">
            <div class="container">
                {% if messages %}
                {% for message in messages %}
                <div class="alert alert-{{message.tags}}">
                    {{message}}
                </div>
                {% endfor %}
                {% endif %}
                {% block content %}{% endblock %}
            </div>
            <div class="col-md-4">
            </div>
        </div>
    </main>


    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js"
        integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
        integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
        crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"
        integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6"
        crossorigin="anonymous"></script>

    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
        integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous">
        </script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.bundle.min.js"></script>
    <script src="https://code.jquery.com/jquery-3.2.1.min.js"></script>

    <script src="{% static 'blog/choices.min.js' %}"></script>
    <script type="text/javascript">
        var secondElement = new Choices('#id_tag', { allowSearch: false });
    </script>
    <script>
        $(document).ready(function () {
            function updateText(btn, newCount, verb) {
                btn.attr("data-likes", newCount)
                btn.text(newCount + "  " + verb)
            }
            $(".like-button").click(function (e) {
                e.preventDefault()
                var this_ = $(this)
                var likeUrl = this_.attr("data-href")
                var likeCount = parseInt(this_.attr("data-likes")) | 0
                var addLike = likeCount + 1
                var removeLike = likeCount
                if (likeUrl) {
                    $.ajax({
                        url: likeUrl,
                        method: "GET",
                        data: {},
                        success: function (data) {
                            console.log(data)
                            var newLikes;
                            if (data.liked) {
                                // add one like
                                updateText($(".like-btn"), addLike, "Like")
                                this_.toggleClass("heart");
                            } else {
                                // remove one like
                                updateText($(".like-btn"), removeLike, "Unlike")
                                this_.removeClass("heart");
                            }
                        },
                        error: function (error) {
                            console.log(error)
                            console.log("error")
                        }
                    })

                }
            })
        })
    </script>
    <script>
        $(document).ready(function () {
            {% block jquery %} {% endblock %}
        })
    </script>

</body>

</html>

blog/templates/blog/home.html
{% extends 'blog/base.html' %}

{% block content %}
{% for post in posts %}
<article class="media content-section">
    <img class="rounded-circle article-img" src="{{ post.author.profile.image.url }}" alt="">
    <div class="media-body">
        <div class="article-metadata">
            <a class="mr-2" href="{% url 'user-posts' post.author.username %}"
                style="color: green;">{{ post.author }}</a>
            <small class="text-muted">{{ post.date_posted|date:"F d, Y" }}</small>
        </div>
        <h2><a class="article-title" href="{{ post.get_absolute_url }}">{{ post.title }}</a></h2>
        <p class="article-content">{{ post.content }}</p>
        <p>
            {% for tag in post.tag.all %}
            <a href="{{ tag.get_absolute_url }}" id="id_tag">#{{ tag.title }}</a>
            {% endfor %}
        </p>
        {% if user.is_authenticated %}
        <div class="like">
            <a data-href="{{ post.get_api_like_url }}" data-likes="{{ post.likes.count }}"
                href="{{ post.get_like_url }}" class="like-info like-button"><i aria-hidden="true"
                    class="fas fa-heart like-ic"></i></a>
        </div>
        {% endif %}
        <a href="{% url 'post-detail' post.slug %}" style="color: #888;">Comments: {{post.comments.count}}</a>
    </div>
</article>
{% endfor %}
{% if is_paginated %}

{% if page_obj.has_previous %}
<a class="btn btn-outline-success mb-4" href="?page=1">First</a>
<a class="btn btn-outline-success mb-4" href="?page={{ page_obj.previous_page_number }}">Previous</a>
{% endif %}

{% for num in page_obj.paginator.page_range %}
{% if page_obj.number == num %}
<a class="btn btn-success mb-4" href="?page={{ num }}">{{ num }}</a>
{% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
<a class="btn btn-outline-success mb-4" href="?page={{ num }}">{{ num }}</a>
{% endif %}
{% endfor %}

{% if page_obj.has_next %}
<a class="btn btn-outline-success mb-4" href="?page={{ page_obj.next_page_number }}">Next</a>
<a class="btn btn-outline-success mb-4" href="?page={{ page_obj.paginator.num_pages }}">Last</a>
{% endif %}

{% endif %}
<hr>
<p>&copy; Made by Bekzod Negmatillaev</p>
{% endblock %}

blog/templates/blog/post_confirm_delete.html
{% extends 'blog/base.html' %}
{% block content %}
<div class="content-section">
    <form method="POST">
        {% csrf_token %}
        <fieldset class="form-group">
            <legend class="border-bottom mb-4">Delete Post</legend>
            <h2>Are you sure you want to delete the post "{{ object.title }}"</h2>
        </fieldset>
        <div class="form-group">
            <button class="btn btn-outline-danger" type="submit">Yes, Delete</button>
            <a class="btn btn-outline-secondary" href="{% url 'post-detail' object.slug %}">Cancel</a>
        </div>
    </form>
</div>
{% endblock content %}

blog/templates/blog/post_detail.html
{% extends 'blog/base.html' %}

{% block content %}
<article class="media content-section">
    <img class="rounded-circle article-img" src="{{ object.author.profile.image.url }}" alt="">
    <div class="media-body">
        <div class="article-metadata">
            <a class="mr-2" href="{% url 'user-posts' object.author.username %}"
                style="color: green;">{{ object.author }}</a>
            <small class="text-muted">{{ object.date_posted|date:"F d, Y" }}</small>
            {% if object.author == user %}
            <div>
                <a class="btn btn-secondary btn-sm mt-1 mb-1" href="{% url 'post-update' object.slug %}">Update</a>
                <a class="btn btn-danger btn-sm mt-1 mb-1" href="{% url 'post-delete' object.slug %}">Delete</a>
            </div>
            {% endif %}
            {% if user.is_authenticated %}
            <div class="like">
                <a data-href="{{ object.get_api_like_url }}" data-likes="{{ object.likes.count }}"
                    href="{{ object.get_like_url }}" class="like-info like-button"><i aria-hidden="true"
                        class="fas fa-heart like-ic"></i></a>
            </div>
            {% endif %}
        </div>
        <h2 class="article-title">{{ object.title }}</h2>
        <p class="article-content">{{ object.content }}</p>
        <hr>
    </div>
</article>

<article class="content-section">
    <!-- COMMENTS -->
    <section class="content mt-5">
        <h3>Add comments</h3>
        <form action="{% url 'comments' post.slug %}" method="POST">
            {% csrf_token %}
            <textarea required name="body" class="form-control" id="" cols="30" rows="10"
                style="width: 100%; height: 50px;"></textarea>
            <button class="btn btn-success" type="submit" style="margin-top: 10px;">Send</button>
        </form>
    </section>
    <section style="margin-top: 50px; display: flex; justify-content: space-around; flex-direction: column;">
        <i>
            <p style="color: #888;">Comments: {{post.comments.count}}</p>
        </i>
        {% for comment in post.comments.all %}
        <div style="
    border: 1px solid #888; 
    padding: 10px; 
    border-radius: 9px;">
            <img class="rounded-circle account-img" src="{{ comment.author.profile.image.url }}">
            <h3>{{comment.author.username}}</h3>
            <p>{{comment.body}}</p>
            <em style="font-size: 12px;">{{comment.date|date:"D j M, Y"}}</em>
        </div>
        {% endfor %}
    </section>
    <!-- END OF THE COMMENTS -->
</article>

{% endblock %}

blog/templates/blog/post_form.html
{% extends 'blog/base.html' %}
{% load crispy_forms_tags %}
{% block content %}
<div class="content-section">
    <form method="POST">
        {% csrf_token %}
        <fieldset class="form-group">
            <legend class="border-bottom mb-4">Blog Post</legend>
            {{ form|crispy }}
        </fieldset>
        <div class="form-group">
            <button class="btn btn-outline-success" type="submit">Post</button>
        </div>
    </form>
</div>
{% endblock content %}

blog/templates/blog/tag.html
{% extends 'blog/base.html' %}

{% block content %}

{% endblock %}

blog/templates/blog/tag_detail.html
{% extends 'blog/base.html' %}

{% block content %}
{% for post in tag.posts.all %}
<article class="media content-section">
    <img class="rounded-circle article-img" src="{{ post.author.profile.image.url }}" alt="">
    <div class="media-body">
        <div class="article-metadata">
            <a class="mr-2" href="{% url 'user-posts' post.author.username %}"
                style="color: green;">{{ post.author }}</a>
            <small class="text-muted">{{ post.date_posted|date:"F d, Y" }}</small>
        </div>
        <h2><a class="article-title" href="{{ post.get_absolute_url }}">{{ post.title }}</a></h2>
        <p class="article-content">{{ post.content }}</p>
        <a href="{% url 'post-detail' post.slug %}" style="color: #888;">Comments: {{post.comments.count}}</a>
    </div>
</article>
{% endfor %}
{% if is_paginated %}

{% if page_obj.has_previous %}
<a class="btn btn-outline-success mb-4" href="?page=1">First</a>
<a class="btn btn-outline-success mb-4" href="?page={{ page_obj.previous_page_number }}">Previous</a>
{% endif %}

{% for num in page_obj.paginator.page_range %}
{% if page_obj.number == num %}
<a class="btn btn-success mb-4" href="?page={{ num }}">{{ num }}</a>
{% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
<a class="btn btn-outline-success mb-4" href="?page={{ num }}">{{ num }}</a>
{% endif %}
{% endfor %}

{% if page_obj.has_next %}
<a class="btn btn-outline-success mb-4" href="?page={{ page_obj.next_page_number }}">Next</a>
<a class="btn btn-outline-success mb-4" href="?page={{ page_obj.paginator.num_pages }}">Last</a>
{% endif %}

{% endif %}
{% endblock %}

blog/templates/blog/test.html
{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
        integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">

    <link rel="stylesheet" href="{% static 'blog/main.css' %}">

    <link rel="stylesheet" href="{% static 'blog/choices.css' %}">

    <link href="https://use.fontawesome.com/releases/v5.0.8/css/all.css" rel="stylesheet">

    <style>
        .main {
            display: flex;
            position: relative;
            flex-wrap: nowrap;
        }

        #content {
            width: 65%;
        }

        #sidebar {
            width: 35%;
            height: 100%;
            right: 0;
            position: fixed;
            border-left: 1px solid #ddd;
        }

        @media screen and (max-width: 970px) {
            #content {
                width: 100%;
                margin: 0;
            }

            #sidebar {
                width: 100%;
                position: relative;
            }

            .main {
                display: flex;
                flex-wrap: wrap;
            }
        }

        i.fa-heart {
            transition: .2s;
        }

        .heart i.fa-heart {
            color: #cc0000;
            font-size: 21px;
        }
    </style>

    {% if title %}
    <title>{{ title }}</title>
    {% else %}
    <title>Blog</title>
    {% endif %}
</head>

<body>

    <header class="site-header">
        <nav class="navbar navbar-expand-md navbar-dark bg-success fixed-top">
            <div class="container">
                <a class="navbar-brand mr-4" href="{% url 'blog-home' %}">MicroTwitter</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarToggle"
                    aria-controls="navbarToggle" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarToggle">
                    <div class="navbar-nav mr-auto">
                        <a class="nav-item nav-link" href="{% url 'blog-home' %}">Home</a>
                    </div>
                    <!-- Navbar Right Side -->
                    <div class="navbar-nav">
                        {% if user.is_authenticated %}
                        <a class="nav-item nav-link" href="{% url 'post-create' %}">New Post</a>
                        <a class="nav-item nav-link" href="{% url 'profile' %}">Profile</a>
                        <a class="nav-item nav-link" href="{% url 'logout' %}">Logout</a>
                        {% else %}
                        <a class="nav-item nav-link" href="{% url 'login' %}">Login</a>
                        <a class="nav-item nav-link" href="{% url 'register' %}">Register</a>
                        {% endif %}
                    </div>
                </div>
            </div>
        </nav>
    </header>
    <main role="main" class="container">
        <div class="row">
            <div class="col-md-8">
                {% if messages %}
                {% for message in messages %}
                <div class="alert alert-{{message.tags}}">
                    {{message}}
                </div>
                {% endfor %}
                {% endif %}
                {% block content %}{% endblock %}
            </div>
            <div class="col-md-4">
                <div class="content-section">
                    <h3>Our Sidebar</h3>
                    <p class='text-muted'>You can put any information here you'd like.
                        <ul class="list-group">
                            <li class="list-group-item list-group-item-light">Latest Posts</li>
                            <li class="list-group-item list-group-item-light">Announcements</li>
                            <li class="list-group-item list-group-item-light">Calendars</li>
                            <li class="list-group-item list-group-item-light">etc</li>
                        </ul>
                    </p>
                </div>
            </div>
        </div>
    </main>


    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js"
        integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
        integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
        crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"
        integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6"
        crossorigin="anonymous"></script>

    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
        integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous">
        </script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.bundle.min.js"></script>
    <script src="https://code.jquery.com/jquery-3.2.1.min.js"></script>

    <script src="{% static 'blog/choices.min.js' %}"></script>
    <script type="text/javascript">
        var secondElement = new Choices('#id_tag', { allowSearch: false });
    </script>
    <script>
        $(document).ready(function () {
            function updateText(btn, newCount, verb) {
                btn.attr("data-likes", newCount)
                btn.text(newCount + "  " + verb)
            }
            $(".like-button").click(function (e) {
                e.preventDefault()
                var this_ = $(this)
                var likeUrl = this_.attr("data-href")
                var likeCount = parseInt(this_.attr("data-likes")) | 0
                var addLike = likeCount + 1
                var removeLike = likeCount
                if (likeUrl) {
                    $.ajax({
                        url: likeUrl,
                        method: "GET",
                        data: {},
                        success: function (data) {
                            console.log(data)
                            var newLikes;
                            if (data.liked) {
                                // add one like
                                updateText($(".like-btn"), addLike, "Like")
                                this_.toggleClass("heart");
                            } else {
                                // remove one like
                                updateText($(".like-btn"), removeLike, "Unlike")
                                this_.removeClass("heart");
                            }
                        },
                        error: function (error) {
                            console.log(error)
                            console.log("error")
                        }
                    })

                }
            })
        })
    </script>
    <script>
        $(document).ready(function () {
            {% block jquery %} {% endblock %}
        })
    </script>

</body>

</html>